using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using System.Collections.Specialized;
using Syncfusion.Windows.Forms;
using System.Collections;
using System.Threading;


namespace Grid_Control
{
    public partial class Form1 : Form
    {        
        public Form1()
        {
            InitializeComponent();
        }       
        private void Form1_Load(object sender, EventArgs e)
        {
            this.gridControl1.ColCount = 2;
            this.gridControl1.RowCount = 60;            
            this.gridControl1.ColStyles[1].CellType = "ComboBox";
            this.gridControl1.ColStyles[1].DataSource = GetTable();
            this.gridControl1.ColStyles[1].DisplayMember = "Name";
            this.gridControl1.ColStyles[1].ValueMember = "ID";
            this.gridControl1.ColStyles[1].DropDownStyle = GridDropDownStyle.Exclusive;
            this.gridControl1.CurrentCellAcceptedChanges += new CancelEventHandler(gridControl1_CurrentCellAcceptedChanges);
            this.gridControl1.QueryCellInfo += new GridQueryCellInfoEventHandler(gridControl1_QueryCellInfo);

            changed = new List<GridRangeInfo>();
            dt = GetTableDetail();
        }

        List<GridRangeInfo> changed;
        DataTable dt;

        void gridControl1_QueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
        {
            if (e.ColIndex == 2 && e.RowIndex > 0)
            {
                e.Style.CellType = "ComboBox";
                if (this.gridControl1[e.RowIndex, 1].Text != "")
                {
                    dt.DefaultView.RowFilter = "([ID]=" + this.gridControl1[e.RowIndex, 1].Text + ")"; ;
                    e.Style.DataSource = dt;
                    e.Style.DropDownStyle = GridDropDownStyle.Exclusive;
                    e.Style.DisplayMember = "Contacts";
                    e.Style.ValueMember = "Contacts";
                }
            }
            if (e.ColIndex == 1)
            {
                GridRangeInfo ran = GridRangeInfo.Cell(e.RowIndex,1);
                if (changed.Contains(ran))
                {              
                    e.Style.Enabled = false;
                }
            }
        }

        void gridControl1_CurrentCellAcceptedChanges(object sender, CancelEventArgs e)
        {
            GridCurrentCell cc=this.gridControl1.CurrentCell;
            if (this.gridControl1.CurrentCell.ColIndex == 1)
            {
                changed.Add(this.gridControl1.CurrentCell.RangeInfo);                
            }
        }
    

        private DataTable GetTable()
        {
            DataTable mt = new DataTable("MyTable");
            mt.Columns.Add("ID", typeof(int));
            mt.Columns.Add("Name", typeof(string));            
            mt.Rows.Add(new Object[] { 3, "A"});            
            mt.Rows.Add(new Object[] { 2, "B" });
            mt.Rows.Add(new Object[] { 1, "C" });
            return mt;
        }
        private DataTable GetTableDetail()
        {
            DataTable mt = new DataTable("MyTable");
            mt.Columns.Add("ID", typeof(int));
            mt.Columns.Add("Contacts", typeof(string));
            mt.Rows.Add(new Object[] { 1, "ADD 1" });
            mt.Rows.Add(new Object[] { 1, "ADD 2" });
            mt.Rows.Add(new Object[] { 2, "ADD 3" });
            mt.Rows.Add(new Object[] { 2, "ADD 4" });
            mt.Rows.Add(new Object[] { 3, "ADD 5" });
            mt.Rows.Add(new Object[] { 3, "ADD 6" });
            return mt;
        }
    }
}
