Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports Syncfusion.Windows.Forms.Grid
Imports System.Collections.Specialized
Imports Syncfusion.Windows.Forms
Imports System.Collections
Imports System.Threading


Namespace Grid_Control
	Partial Public Class Form1
		Inherits Form
		Public Sub New()
			InitializeComponent()
		End Sub
		Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
			Me.gridControl1.ColCount = 2
			Me.gridControl1.RowCount = 60
			Me.gridControl1.ColStyles(1).CellType = "ComboBox"
			Me.gridControl1.ColStyles(1).DataSource = GetTable()
			Me.gridControl1.ColStyles(1).DisplayMember = "Name"
			Me.gridControl1.ColStyles(1).ValueMember = "ID"
			Me.gridControl1.ColStyles(1).DropDownStyle = GridDropDownStyle.Exclusive
			AddHandler gridControl1.CurrentCellAcceptedChanges, AddressOf gridControl1_CurrentCellAcceptedChanges
			AddHandler gridControl1.QueryCellInfo, AddressOf gridControl1_QueryCellInfo

			changed = New List(Of GridRangeInfo)()
			dt = GetTableDetail()
		End Sub

		Private changed As List(Of GridRangeInfo)
		Private dt As DataTable

		Private Sub gridControl1_QueryCellInfo(ByVal sender As Object, ByVal e As GridQueryCellInfoEventArgs)
			If e.ColIndex = 2 AndAlso e.RowIndex > 0 Then
				e.Style.CellType = "ComboBox"
				If Me.gridControl1(e.RowIndex, 1).Text <> "" Then
					dt.DefaultView.RowFilter = "([ID]=" & Me.gridControl1(e.RowIndex, 1).Text & ")"

					e.Style.DataSource = dt
					e.Style.DropDownStyle = GridDropDownStyle.Exclusive
					e.Style.DisplayMember = "Contacts"
					e.Style.ValueMember = "Contacts"
				End If
			End If
			If e.ColIndex = 1 Then
				Dim ran As GridRangeInfo = GridRangeInfo.Cell(e.RowIndex,1)
				If changed.Contains(ran) Then
					e.Style.Enabled = False
				End If
			End If
		End Sub

		Private Sub gridControl1_CurrentCellAcceptedChanges(ByVal sender As Object, ByVal e As CancelEventArgs)
			Dim cc As GridCurrentCell=Me.gridControl1.CurrentCell
			If Me.gridControl1.CurrentCell.ColIndex = 1 Then
				changed.Add(Me.gridControl1.CurrentCell.RangeInfo)
			End If
		End Sub


		Private Function GetTable() As DataTable
			Dim mt As New DataTable("MyTable")
			mt.Columns.Add("ID", GetType(Integer))
			mt.Columns.Add("Name", GetType(String))
			mt.Rows.Add(New Object() { 3, "A"})
			mt.Rows.Add(New Object() { 2, "B" })
			mt.Rows.Add(New Object() { 1, "C" })
			Return mt
		End Function
		Private Function GetTableDetail() As DataTable
			Dim mt As New DataTable("MyTable")
			mt.Columns.Add("ID", GetType(Integer))
			mt.Columns.Add("Contacts", GetType(String))
			mt.Rows.Add(New Object() { 1, "ADD 1" })
			mt.Rows.Add(New Object() { 1, "ADD 2" })
			mt.Rows.Add(New Object() { 2, "ADD 3" })
			mt.Rows.Add(New Object() { 2, "ADD 4" })
			mt.Rows.Add(New Object() { 3, "ADD 5" })
			mt.Rows.Add(New Object() { 3, "ADD 6" })
			Return mt
		End Function
	End Class
End Namespace
